header {* The exception monad *}

theory ExceptionMonad
imports "../../../Extensions/AWE_HOL"
begin


datatype 'a exn  = Error string | Just 'a

thymorph exn : "../MonadType" \<longrightarrow> ExceptionMonad
type_map: [("'a M" \<mapsto> "'a exn")]

instantiate_theory "../MonadOps" by_thymorph exn

defs
 eta_def : "eta \<equiv> Just"

primrec
"(Error msg >>= f) = Error msg"
"(Just x >>= f) = f x"

instantiate_theory "../MonadAxms" by_thymorph exn'

lemma mon_assoc:
"(s >>= t >>= u) = (s >>= (\<lambda>x. t x >>= u))"
by(case_tac s, simp_all) 

lemma mon_runit:
"(t >>= eta) = t"
by(case_tac t, simp_all add: eta_def) 

thymorph exn_monad by_sigmorph exn''

instantiate_theory "../MonadBase" by_thymorph exn_monad
translate_thm "MonadBase.joinM_eta" along exn_monad'

end
