header {* Lists as Monads *}

theory ListMonad 
imports "../../../Extensions/AWE_HOL"
begin

thymorph list : "../MonadType" \<longrightarrow> ListMonad
type_map: [("'a M" \<mapsto> "'a list")]


instantiate_theory "../MonadOps" by_thymorph list

defs
eta_def : "eta x \<equiv> [x]"

primrec
"([] >>= f) = []"
"((x#xs) >>= f) = ((f x)@(xs >>= f))"


instantiate_theory "../MonadAxms" by_thymorph list'


lemma bind_concat : " (l >>= f) = (concat (map f l)) " by (induct l, simp_all)
lemma runit : " (t >>= eta) = t " by (induct t, simp_all add: eta_def)
lemma assoc : " ((s >>= t) >>= u) = (s >>= (\<lambda> x. (t x >>= u))) "
by (simp add: bind_concat, induct s, simp_all)

thymorph list_monad by_sigmorph list''

instantiate_theory "../MonadBase" by_thymorph list_monad


end

